HitsMode5 = LibStub("AceAddon-3.0"):NewAddon("HitsMode5", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
HitsMode5.MINOR_VERSION = tonumber(("$Revision: 17 $"):match("%d+"))
local L = LibStub("AceLocale-3.0"):GetLocale("HitsMode5")
local HitsMode5 = HitsMode5
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("HitsMode5", {label = "HitsMode5", type = "data source", icon = "Interface\\Icons\\Ability_CriticalStrike", text = ""})




--[[
      LOCALS -------------------------------------------------------------------------------------------------------------------
  ]]

local isEnabled = false
local NUM_HELPARTICLES = 1
local filters = {}
local specialEvents = {
	"PLAYER_REGEN_DISABLED",
	"PLAYER_REGEN_ENABLED",
	"CHAT_MSG_COMBAT_XP_GAIN",
	"CHAT_MSG_LOOT",
	"CHAT_MSG_COMBAT_FACTION_CHANGE",
	"CHAT_MSG_COMBAT_HONOR_GAIN",
	"CHAT_MSG_MONEY",
	"CHAT_MSG_SKILL",
}




--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local bit_bor = _G.bit.bor
local bit_band = _G.bit.band
local tinsert = _G.tinsert
local tremove = _G.tremove
local math_floor = _G.math.floor
local format = _G.format
local gsub = _G.gsub
local strsub = _G.strsub
local strreplace = _G.strreplace
local strsplit = _G.strsplit

local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local COMBATLOG_OBJECT_AFFILIATION_PARTY = COMBATLOG_OBJECT_AFFILIATION_PARTY
local COMBATLOG_OBJECT_AFFILIATION_RAID = COMBATLOG_OBJECT_AFFILIATION_RAID
local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = COMBATLOG_OBJECT_AFFILIATION_OUTSIDER
local COMBATLOG_OBJECT_AFFILIATION_MASK = COMBATLOG_OBJECT_AFFILIATION_MASK
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE
local COMBATLOG_OBJECT_REACTION_MASK = COMBATLOG_OBJECT_REACTION_MASK
local COMBATLOG_OBJECT_CONTROL_PLAYER = COMBATLOG_OBJECT_CONTROL_PLAYER
local COMBATLOG_OBJECT_CONTROL_NPC = COMBATLOG_OBJECT_CONTROL_NPC
local COMBATLOG_OBJECT_CONTROL_MASK = COMBATLOG_OBJECT_CONTROL_MASK
local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
local COMBATLOG_OBJECT_TYPE_NPC = COMBATLOG_OBJECT_TYPE_NPC
local COMBATLOG_OBJECT_TYPE_PET = COMBATLOG_OBJECT_TYPE_PET
local COMBATLOG_OBJECT_TYPE_GUARDIAN = COMBATLOG_OBJECT_TYPE_GUARDIAN
local COMBATLOG_OBJECT_TYPE_OBJECT = COMBATLOG_OBJECT_TYPE_OBJECT
local COMBATLOG_OBJECT_TYPE_MASK = COMBATLOG_OBJECT_TYPE_MASK
local COMBATLOG_OBJECT_TARGET = COMBATLOG_OBJECT_TARGET
local COMBATLOG_OBJECT_FOCUS = COMBATLOG_OBJECT_FOCUS
local COMBATLOG_OBJECT_MAINTANK = COMBATLOG_OBJECT_MAINTANK
local COMBATLOG_OBJECT_MAINASSIST = COMBATLOG_OBJECT_MAINASSIST
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8
local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
local COMBATLOG_OBJECT_SPECIAL_MASK = COMBATLOG_OBJECT_SPECIAL_MASK
local COMBATLOG_FILTER_ME = COMBATLOG_FILTER_ME
local COMBATLOG_FILTER_MINE = COMBATLOG_FILTER_MINE
local COMBATLOG_FILTER_MY_PET = COMBATLOG_FILTER_MY_PET
local COMBATLOG_FILTER_FRIENDLY_UNITS = COMBATLOG_FILTER_FRIENDLY_UNITS
local COMBATLOG_FILTER_HOSTILE_UNITS = COMBATLOG_FILTER_HOSTILE_UNITS
local COMBATLOG_FILTER_HOSTILE_PLAYERS = COMBATLOG_FILTER_HOSTILE_PLAYERS
local COMBATLOG_FILTER_NEUTRAL_UNITS = COMBATLOG_FILTER_NEUTRAL_UNITS
local COMBATLOG_FILTER_UNKNOWN_UNITS = COMBATLOG_FILTER_UNKNOWN_UNITS
local COMBATLOG_FILTER_EVERYTHING = COMBATLOG_FILTER_EVERYTHING
local COMBATLOG = COMBATLOG
local AURA_TYPE_BUFF = AURA_TYPE_BUFF
local AURA_TYPE_DEBUFF = AURA_TYPE_DEBUFF
local SPELL_POWER_MANA = SPELL_POWER_MANA
local SPELL_POWER_RAGE = SPELL_POWER_RAGE
local SPELL_POWER_FOCUS = SPELL_POWER_FOCUS
local SPELL_POWER_ENERGY = SPELL_POWER_ENERGY
local SPELL_POWER_HAPPINESS = SPELL_POWER_HAPPINESS
local SPELL_POWER_RUNES = SPELL_POWER_RUNES
local SPELL_POWER_RUNIC_POWER = SPELL_POWER_RUNIC_POWER
local SCHOOL_MASK_NONE = SCHOOL_MASK_NONE
local SCHOOL_MASK_PHYSICAL = SCHOOL_MASK_PHYSICAL
local SCHOOL_MASK_HOLY = SCHOOL_MASK_HOLY
local SCHOOL_MASK_FIRE = SCHOOL_MASK_FIRE
local SCHOOL_MASK_NATURE = SCHOOL_MASK_NATURE
local SCHOOL_MASK_FROST = SCHOOL_MASK_FROST
local SCHOOL_MASK_SHADOW = SCHOOL_MASK_SHADOW
local SCHOOL_MASK_ARCANE = SCHOOL_MASK_ARCANE
local COMBATLOG_LIMIT_PER_FRAME = COMBATLOG_LIMIT_PER_FRAME
local COMBATLOG_HIGHLIGHT_MULTIPLIER = COMBATLOG_HIGHLIGHT_MULTIPLIER
local COMBATLOG_DEFAULT_COLORS = COMBATLOG_DEFAULT_COLORS
local COMBATLOG_DEFAULT_SETTINGS = COMBATLOG_DEFAULT_SETTINGS
local COMBATLOG_ICON_RAIDTARGET1 = COMBATLOG_ICON_RAIDTARGET1
local COMBATLOG_ICON_RAIDTARGET2 = COMBATLOG_ICON_RAIDTARGET2
local COMBATLOG_ICON_RAIDTARGET3 = COMBATLOG_ICON_RAIDTARGET3
local COMBATLOG_ICON_RAIDTARGET4 = COMBATLOG_ICON_RAIDTARGET4
local COMBATLOG_ICON_RAIDTARGET5 = COMBATLOG_ICON_RAIDTARGET5
local COMBATLOG_ICON_RAIDTARGET6 = COMBATLOG_ICON_RAIDTARGET6
local COMBATLOG_ICON_RAIDTARGET7 = COMBATLOG_ICON_RAIDTARGET7
local COMBATLOG_ICON_RAIDTARGET8 = COMBATLOG_ICON_RAIDTARGET8
local COMBATLOG_EVENT_LIST = COMBATLOG_EVENT_LIST



--[[
      UTILITIES ----------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:tcopy(to, from)
 for k, v in pairs(from) do
  if(type(v) == "table") then
   to[k] = {}
   HitsMode5:tcopy(to[k], v)
  else
   to[k] = v
  end
 end
end

function boolToString(b)
	if b == true then return "true" end
	if b == false then return "false" end
	if b == nil then return "nil" end
end



--[[
      HELP SYSTEM --------------------------------------------------------------------------------------------------------------
  ]]

do
	local i
	for i = 1, NUM_HELPARTICLES do
		HelpLib.AddQuestion({
			q = L["help_question_"..i],
			a = L["help_answer_"..i],
			cat = "HitsMode5",
		});
	end
end

function HitsMode5:CheckHelpLoaded()
 if (KBSetup_IsLoaded()) then
  KnowledgeBaseFrameEditBox:SetText("")
  UIDropDownMenu_SetSelectedName(KnowledgeBaseFrameCategoryDropDown, "HitsMode5")
  KnowledgeBaseFrame_Search(1)
 else
		self:ScheduleTimer("CheckHelpLoaded", 0.2)
 end
end



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnInitialize()
	-- Register database and options
 self.db = LibStub("AceDB-3.0"):New("HitsMode5DB", self.defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HitsMode5", self.options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HitsMode5", "HitsMode5")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HitsMode5-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HitsMode5-Profiles", "Profiles", "HitsMode5")
	
	-- Register for slash commands
	self:RegisterChatCommand("hitsmode", "ChatCommand")
	self:RegisterChatCommand("hm", "ChatCommand")
	
 -- Initialize settings
	self:ReloadSettings()
end


function HitsMode5:OnEnable()
	-- Make sure the Blizzard Combat Log is loaded
	local result = LoadAddOn("Blizzard_CombatLog")
	if result ~= 1 then
		self:Print(format(L["Unable to load Blizzard Combat Log. HitsMode5 cannot be enabled. (Reason: %s)"], _G["ADDON_"..result]))
		self:Disable()
		return
	end
	
	-- Register for events
 for k, v in pairs(specialEvents) do
  self:RegisterEvent(v, "OnSpecialEvent");
 end
 self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent")
 
 -- Turn us on
	isEnabled = true

--[===[@debug@
	self:Print(L["Loaded"])
--@end-debug@]===]
end


function HitsMode5:OnDisable()
	-- Unregister all events
	self:UnregisterAllEvents()

	-- Turn us off
	isEnabled = false
end


function HitsMode5:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(HitsMode5, "hm", "HitsMode5", input)
	end
end



--[[
      FILTERS ------------------------------------------------------------------------------------------------------------------
  ]]

local Filter = {}
local mt = {__index = Filter}

function Filter:new()
 return setmetatable({
		someproperty = 1
 }, mt)
end

function Filter:AddOptions()
	local db = self.db
	
	local options
	options = {
  type = "group",
		name = function() return db.name end,
  args = {


--[[ Filter root menu ]] ------------------------------------------------------------------------------------------------------------

			enable = {
				type = "toggle",
				name = L["Enable filter"],
				desc = L["Enables the filter."],
				get = function() return db.enabled end,
				set = function(win, val) db.enabled = val end,
				order = 1,
			}, -- enable
			
			
			rename = {
				type = "input",
				name = L["Rename filter"],
				desc = L["Enter the name for the filter."],
				get = function() return db.name end,
				set = function(win, val) if val ~= db.name and val ~= "" then db.name = val end end,
				order = 2,
			}, -- rename
			
			
			copy = {
				type = "input",
				name = L["Copy filter"],
				desc = L["Create a copy of this filter by entering a new name and clicking Okay."],
				get = function() return "" end,
				set = function(self, val)
					if val and val ~= "" then
						local newFilter = {}
						HitsMode5:tcopy(newFilter, db)
						HitsMode5:CreateFilter(val, newFilter)
					end
				end,
				order = 3,
			}, -- copy
			
			
--[[ Display ]]----------------------------------------------------------------------------------------------------------------------

			display = {
				type = "group",
				name = L["Display"],
				order = 3,
				args = {
				}
			}, -- display
			
			
--[[ Source units ]]-----------------------------------------------------------------------------------------------------------------

			sourceUnits = {
				type = "group",
				name = L["Source Units"],
				order = 4,
				args = {
					head = {
						type = "header",
						name = L["Source Units"],
						order = 0
					},
					desc = {
						type = "description",
						name = L["Choose which source unit types to display events for."],
						order = 1
					},
					
					affiliation = {
						type = "multiselect",
						name = L["Affiliation"],
						desc = L["You must choose at least one item from this category."],
						order = 2,
						values = {
							["COMBATLOG_OBJECT_AFFILIATION_MINE"] = L["COMBATLOG_OBJECT_AFFILIATION_MINE"],
							["COMBATLOG_OBJECT_AFFILIATION_PARTY"] = L["COMBATLOG_OBJECT_AFFILIATION_PARTY"],
							["COMBATLOG_OBJECT_AFFILIATION_RAID"] = L["COMBATLOG_OBJECT_AFFILIATION_RAID"],
							["COMBATLOG_OBJECT_AFFILIATION_OUTSIDER"] = L["COMBATLOG_OBJECT_AFFILIATION_OUTSIDER"]
						},
						
						get = function(info, key)
							return db.sourceFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.sourceUnits.args.affiliation.values) do
									if db.sourceFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.sourceFlags[_G[key]] = state
						end
						
					}, -- affiliation multiselect control
					
					reaction = {
						type = "multiselect",
						name = L["Reaction"],
						desc = L["You must choose at least one item from this category."],
						order = 3,
						values = {
							["COMBATLOG_OBJECT_REACTION_FRIENDLY"] = L["COMBATLOG_OBJECT_REACTION_FRIENDLY"],
							["COMBATLOG_OBJECT_REACTION_NEUTRAL"] = L["COMBATLOG_OBJECT_REACTION_NEUTRAL"],
							["COMBATLOG_OBJECT_REACTION_HOSTILE"] = L["COMBATLOG_OBJECT_REACTION_HOSTILE"],
						},
						
						get = function(info, key)
							return db.sourceFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.sourceUnits.args.reaction.values) do
									if db.sourceFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.sourceFlags[_G[key]] = state
						end
						
					}, -- reaction multiselect control

					ownership = {
						type = "multiselect",
						name = L["Ownership"],
						desc = L["You must choose at least one item from this category."],
						order = 4,
						values = {
							["COMBATLOG_OBJECT_CONTROL_PLAYER"] = L["COMBATLOG_OBJECT_CONTROL_PLAYER"],
							["COMBATLOG_OBJECT_CONTROL_NPC"] = L["COMBATLOG_OBJECT_CONTROL_NPC"],
						},
						
						get = function(info, key)
							return db.sourceFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.sourceUnits.args.ownership.values) do
									if db.sourceFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.sourceFlags[_G[key]] = state
						end
						
					}, -- ownership multiselect control

					unitType = {
						type = "multiselect",
						name = L["Unit Type"],
						desc = L["You must choose at least one item from this category."],
						order = 5,
						values = {
							["COMBATLOG_OBJECT_TYPE_PLAYER"] = L["COMBATLOG_OBJECT_TYPE_PLAYER"],
							["COMBATLOG_OBJECT_TYPE_NPC"] = L["COMBATLOG_OBJECT_TYPE_NPC"],
							["COMBATLOG_OBJECT_TYPE_PET"] = L["COMBATLOG_OBJECT_TYPE_PET"],
							["COMBATLOG_OBJECT_TYPE_GUARDIAN"] = L["COMBATLOG_OBJECT_TYPE_GUARDIAN"],
							["COMBATLOG_OBJECT_TYPE_OBJECT"] = L["COMBATLOG_OBJECT_TYPE_OBJECT"]
						},
						
						get = function(info, key)
							return db.sourceFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.sourceUnits.args.unitType.values) do
									if db.sourceFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.sourceFlags[_G[key]] = state
						end
						
					}, -- unitType multiselect control
					
					specialCases = {
						type = "multiselect",
						name = L["Unit Type"],
						desc = L["These are optional. Select \"None\" to exclude all special cases."],
						order = 6,
						values = {
							["COMBATLOG_OBJECT_TARGET"] = L["COMBATLOG_OBJECT_TARGET"],
							["COMBATLOG_OBJECT_FOCUS"] = L["COMBATLOG_OBJECT_FOCUS"],
							["COMBATLOG_OBJECT_MAINTANK"] = L["COMBATLOG_OBJECT_MAINTANK"],
							["COMBATLOG_OBJECT_MAINASSIST"] = L["COMBATLOG_OBJECT_MAINASSIST"],
							["COMBATLOG_OBJECT_RAIDTARGET1"] = L["COMBATLOG_OBJECT_RAIDTARGET1"].." "..ICON_LIST[1].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET2"] = L["COMBATLOG_OBJECT_RAIDTARGET2"].." "..ICON_LIST[2].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET3"] = L["COMBATLOG_OBJECT_RAIDTARGET3"].." "..ICON_LIST[3].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET4"] = L["COMBATLOG_OBJECT_RAIDTARGET4"].." "..ICON_LIST[4].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET5"] = L["COMBATLOG_OBJECT_RAIDTARGET5"].." "..ICON_LIST[5].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET6"] = L["COMBATLOG_OBJECT_RAIDTARGET6"].." "..ICON_LIST[6].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET7"] = L["COMBATLOG_OBJECT_RAIDTARGET7"].." "..ICON_LIST[7].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET8"] = L["COMBATLOG_OBJECT_RAIDTARGET8"].." "..ICON_LIST[8].."0|t",
							["COMBATLOG_OBJECT_NONE"] = L["COMBATLOG_OBJECT_NONE"]
						},
						
						get = function(info, key)
							return db.sourceFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							db.sourceFlags[_G[key]] = state
						end
						
					}, -- specialCases multiselect control

					whiteList = {
						type = "input",
						name = L["Name Is"],
						desc = L["Enter a comma-separated list of names. Only events with names that are on this list will be shown."],
						order = 7,
						get = function() return db.sourceWhiteList or "" end,
						set = function(self, value) db.sourceWhiteList = value end
					}, -- whiteList
					
					blackList = {
						type = "input",
						name = L["Name Is Not"],
						desc = L["Enter a comma-separated list of names. Only events with names that are not on this list will be shown."],
						order = 7,
						get = function() return db.sourceBlackList or "" end,
						set = function(self, value) db.sourceBlackList = value end
					} -- blackList
					
					
				}
			}, -- sourceUnits


--[[ Destination units ]]------------------------------------------------------------------------------------------------------------

			destUnits = {
				type = "group",
				name = L["Destination Units"],
				order = 5,
				args = {
					head = {
						type = "header",
						name = L["Destination Units"],
						order = 0
					},
					desc = {
						type = "description",
						name = L["Choose which destination unit types to display events for."],
						order = 1
					},
					
					affiliation = {
						type = "multiselect",
						name = L["Affiliation"],
						desc = L["You must choose at least one item from this category."],
						order = 2,
						values = {
							["COMBATLOG_OBJECT_AFFILIATION_MINE"] = L["COMBATLOG_OBJECT_AFFILIATION_MINE"],
							["COMBATLOG_OBJECT_AFFILIATION_PARTY"] = L["COMBATLOG_OBJECT_AFFILIATION_PARTY"],
							["COMBATLOG_OBJECT_AFFILIATION_RAID"] = L["COMBATLOG_OBJECT_AFFILIATION_RAID"],
							["COMBATLOG_OBJECT_AFFILIATION_OUTSIDER"] = L["COMBATLOG_OBJECT_AFFILIATION_OUTSIDER"]
						},
						
						get = function(info, key)
							return db.destFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.destUnits.args.affiliation.values) do
									if db.destFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.destFlags[_G[key]] = state
						end
						
					}, -- affiliation multiselect control
					
					reaction = {
						type = "multiselect",
						name = L["Reaction"],
						desc = L["You must choose at least one item from this category."],
						order = 3,
						values = {
							["COMBATLOG_OBJECT_REACTION_FRIENDLY"] = L["COMBATLOG_OBJECT_REACTION_FRIENDLY"],
							["COMBATLOG_OBJECT_REACTION_NEUTRAL"] = L["COMBATLOG_OBJECT_REACTION_NEUTRAL"],
							["COMBATLOG_OBJECT_REACTION_HOSTILE"] = L["COMBATLOG_OBJECT_REACTION_HOSTILE"],
						},
						
						get = function(info, key)
							return db.destFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.destUnits.args.reaction.values) do
									if db.destFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.destFlags[_G[key]] = state
						end
						
					}, -- reaction multiselect control

					ownership = {
						type = "multiselect",
						name = L["Ownership"],
						desc = L["You must choose at least one item from this category."],
						order = 4,
						values = {
							["COMBATLOG_OBJECT_CONTROL_PLAYER"] = L["COMBATLOG_OBJECT_CONTROL_PLAYER"],
							["COMBATLOG_OBJECT_CONTROL_NPC"] = L["COMBATLOG_OBJECT_CONTROL_NPC"],
						},
						
						get = function(info, key)
							return db.destFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.destUnits.args.ownership.values) do
									if db.destFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.destFlags[_G[key]] = state
						end
						
					}, -- ownership multiselect control

					unitType = {
						type = "multiselect",
						name = L["Unit Type"],
						desc = L["You must choose at least one item from this category."],
						order = 5,
						values = {
							["COMBATLOG_OBJECT_TYPE_PLAYER"] = L["COMBATLOG_OBJECT_TYPE_PLAYER"],
							["COMBATLOG_OBJECT_TYPE_NPC"] = L["COMBATLOG_OBJECT_TYPE_NPC"],
							["COMBATLOG_OBJECT_TYPE_PET"] = L["COMBATLOG_OBJECT_TYPE_PET"],
							["COMBATLOG_OBJECT_TYPE_GUARDIAN"] = L["COMBATLOG_OBJECT_TYPE_GUARDIAN"],
							["COMBATLOG_OBJECT_TYPE_OBJECT"] = L["COMBATLOG_OBJECT_TYPE_OBJECT"]
						},
						
						get = function(info, key)
							return db.destFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							if state == false then -- Must leave at least one selected at all times
								local count = 0
								for k, v in pairs(options.args.destUnits.args.unitType.values) do
									if db.destFlags[_G[k]] == true then count = count + 1 end
								end
								if count <= 1 then return end
							end
							db.destFlags[_G[key]] = state
						end
						
					}, -- unitType multiselect control
					
					specialCases = {
						type = "multiselect",
						name = L["Unit Type"],
						desc = L["These are optional. Select \"None\" to exclude all special cases."],
						order = 6,
						values = {
							["COMBATLOG_OBJECT_TARGET"] = L["COMBATLOG_OBJECT_TARGET"],
							["COMBATLOG_OBJECT_FOCUS"] = L["COMBATLOG_OBJECT_FOCUS"],
							["COMBATLOG_OBJECT_MAINTANK"] = L["COMBATLOG_OBJECT_MAINTANK"],
							["COMBATLOG_OBJECT_MAINASSIST"] = L["COMBATLOG_OBJECT_MAINASSIST"],
							["COMBATLOG_OBJECT_RAIDTARGET1"] = L["COMBATLOG_OBJECT_RAIDTARGET1"].." "..ICON_LIST[1].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET2"] = L["COMBATLOG_OBJECT_RAIDTARGET2"].." "..ICON_LIST[2].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET3"] = L["COMBATLOG_OBJECT_RAIDTARGET3"].." "..ICON_LIST[3].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET4"] = L["COMBATLOG_OBJECT_RAIDTARGET4"].." "..ICON_LIST[4].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET5"] = L["COMBATLOG_OBJECT_RAIDTARGET5"].." "..ICON_LIST[5].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET6"] = L["COMBATLOG_OBJECT_RAIDTARGET6"].." "..ICON_LIST[6].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET7"] = L["COMBATLOG_OBJECT_RAIDTARGET7"].." "..ICON_LIST[7].."0|t",
							["COMBATLOG_OBJECT_RAIDTARGET8"] = L["COMBATLOG_OBJECT_RAIDTARGET8"].." "..ICON_LIST[8].."0|t",
							["COMBATLOG_OBJECT_NONE"] = L["COMBATLOG_OBJECT_NONE"]
						},
						
						get = function(info, key)
							return db.destFlags[_G[key]]
						end,
						
						set = function(info, key, state)
							db.destFlags[_G[key]] = state
						end
						
					}, -- specialCases multiselect control

					whiteList = {
						type = "input",
						name = L["Name Is"],
						desc = L["Enter a comma-separated list of names. Only events with names that are on this list will be shown."],
						order = 7,
						get = function() return db.destWhiteList or "" end,
						set = function(self, value) db.destWhiteList = value end
					}, -- whiteList
					
					blackList = {
						type = "input",
						name = L["Name Is Not"],
						desc = L["Enter a comma-separated list of names. Only events with names that are not on this list will be shown."],
						order = 7,
						get = function() return db.destBlackList or "" end,
						set = function(self, value) db.destBlackList = value end
					} -- blackList
					
					
				}
			}, -- destUnits


--[[ Combat events ]]----------------------------------------------------------------------------------------------------------------

			events = {
				type = "group",
				name = L["Combat Events"],
				order = 6,
				args = {
					head = {
						type = "header",
						name = L["Combat Events"],
						order = 0
					},
					desc = {
						type = "description",
						name = L["Determines which combat log events will be shown. This list is restricted to Blizzard combat log events only."],
						order = 1
					},
					
					events = {
						type = "multiselect",
						name = "",
						order = 2,
						values = {
							["ALL"] = L["ALL"],
							["ENVIRONMENTAL_DAMAGE"] = L["ENVIRONMENTAL_DAMAGE"],
							["SWING_DAMAGE"] = L["SWING_DAMAGE"],
							["SWING_MISSED"] = L["SWING_MISSED"],
							["RANGE_DAMAGE"] = L["RANGE_DAMAGE"],
							["RANGE_MISSED"] = L["RANGE_MISSED"],
							["SPELL_CAST_START"] = L["SPELL_CAST_START"],
							["SPELL_CAST_SUCCESS"] = L["SPELL_CAST_SUCCESS"],
							["SPELL_CAST_FAILED"] = L["SPELL_CAST_FAILED"],
							["SPELL_MISSED"] = L["SPELL_MISSED"],
							["SPELL_DAMAGE"] = L["SPELL_DAMAGE"],
							["SPELL_HEAL"] = L["SPELL_HEAL"],
							["SPELL_PERIODIC_HEAL"] = L["SPELL_PERIODIC_HEAL"],
							["SPELL_ENERGIZE"] = L["SPELL_ENERGIZE"],
							["SPELL_PERIODIC_ENERGIZE"] = L["SPELL_PERIODIC_ENERGIZE"],
							["SPELL_DRAIN"] = L["SPELL_DRAIN"],
							["SPELL_PERIODIC_DRAIN"] = L["SPELL_PERIODIC_DRAIN"],
							["SPELL_LEECH"] = L["SPELL_LEECH"],
							["SPELL_PERIODIC_LEECH"] = L["SPELL_PERIODIC_LEECH"],
							["SPELL_INTERRUPT"] = L["SPELL_INTERRUPT"],
							["SPELL_EXTRA_ATTACKS"] = L["SPELL_EXTRA_ATTACKS"],
							["SPELL_AURA_APPLIED"] = L["SPELL_AURA_APPLIED"],
							["SPELL_AURA_APPLIED_DOSE"] = L["SPELL_AURA_APPLIED_DOSE"],
							["SPELL_AURA_REMOVED"] = L["SPELL_AURA_REMOVED"],
							["SPELL_AURA_REMOVED_DOSE"] = L["SPELL_AURA_REMOVED_DOSE"],
							["SPELL_DISPEL"] = L["SPELL_DISPEL"],
							["SPELL_DISPEL_FAILED"] = L["SPELL_DISPEL_FAILED"],
							["SPELL_STOLEN"] = L["SPELL_STOLEN"],
							["ENCHANT_APPLIED"] = L["ENCHANT_APPLIED"],
							["ENCHANT_REMOVED"] = L["ENCHANT_REMOVED"],
							["SPELL_PERIODIC_DAMAGE"] = L["SPELL_PERIODIC_DAMAGE"],
							["SPELL_PERIODIC_MISSED"] = L["SPELL_PERIODIC_MISSED"],
							["DAMAGE_SHIELD"] = L["DAMAGE_SHIELD"],
							["DAMAGE_SHIELD_MISSED"] = L["DAMAGE_SHIELD_MISSED"],
							["DAMAGE_SPLIT"] = L["DAMAGE_SPLIT"],
							["SPELL_INSTAKILL"] = L["SPELL_INSTAKILL"],
							["PARTY_KILL"] = L["PARTY_KILL"],
							["UNIT_DIED"] = L["UNIT_DIED"],
							["UNIT_DESTROYED"] = L["UNIT_DESTROYED"],
							["UNIT_DISSIPATES"] = L["UNIT_DISSIPATES"],
							["SPELL_BUILDING_HEAL"] = L["SPELL_BUILDING_HEAL"],
							["SPELL_BUILDING_DAMAGE"] = L["SPELL_BUILDING_DAMAGE"],
							["SPELL_SUMMON"] = L["SPELL_SUMMON"],
							["SPELL_CREATE"] = L["SPELL_CREATE"],
							["SPELL_RESURRECT"] = L["SPELL_RESURRECT"],
							["SPELL_AURA_REFRESH"] = L["SPELL_AURA_REFRESH"],
							["SPELL_AURA_BROKEN"] = L["SPELL_AURA_BROKEN"],
							["SPELL_AURA_BROKEN_SPELL"] = L["SPELL_AURA_BROKEN_SPELL"],
						},
						
						get = function(info, key)
							if key == "ALL" then
								for k, v in pairs(options.args.events.args.events.values) do
									if (db.events[k] == false or db.events[k] == nil) and k ~= "ALL" then return false end
								end
								return true
							end
							return db.events[key]
						end,
						
						set = function(info, key, state)
							if key == "ALL" then
								for k, v in pairs(options.args.events.args.events.values) do
									db.events[k] = state
								end
							end
							db.events[key] = state
						end
						
					} -- events multiselect control
				}
			}, -- combat events


--[[ Special events ]]---------------------------------------------------------------------------------------------------------------

			specialEvents = {
				type = "group",
				name = L["Special Events"],
				order = 7,
				args = {
					head = {
						type = "header",
						name = L["Special Events"],
						order = 0
					},
					desc = {
						type = "description",
						name = L["Special events are not part of the normal combat log. You can still display these events with HitsMode5. They will only show for you (not others), and will not respect any source or destination unit filters."],
						order = 1
					},
					
					events = {
						type = "multiselect",
						name = "",
						order = 2,
						values = {
							["ALL"] = L["ALL"],
							["CHAT_MSG_COMBAT_XP_GAIN"] = L["CHAT_MSG_COMBAT_XP_GAIN"],
							["CHAT_MSG_LOOT"] = L["CHAT_MSG_LOOT"],
							["CHAT_MSG_COMBAT_FACTION_CHANGE"] = L["CHAT_MSG_COMBAT_FACTION_CHANGE"],
							["CHAT_MSG_COMBAT_HONOR_GAIN"] = L["CHAT_MSG_COMBAT_HONOR_GAIN"],
							["CHAT_MSG_MONEY"] = L["CHAT_MSG_MONEY"],
							["CHAT_MSG_SKILL"] = L["CHAT_MSG_SKILL"],
						},
						
						get = function(info, key)
							if key == "ALL" then
								for k, v in pairs(options.args.specialEvents.args.events.values) do
									if (db.specialEvents[k] == false or db.specialEvents[k] == nil) and k ~= "ALL" then return false end
								end
								return true
							end
							return db.specialEvents[key]
						end,
						
						set = function(info, key, state)
							if key == "ALL" then
								for k, v in pairs(options.args.specialEvents.args.events.values) do
									db.specialEvents[k] = state
								end
							end
							db.specialEvents[key] = state
						end
						
					} -- special events multiselect control
				}
			} -- special events

  
		} -- args
	} -- options

	HitsMode5.options.args.filters.args[db.name] = options
end


function Filter:destroy()
	-- Destroy a filter
end


function HitsMode5:GetFilters()
	return filters
end


function HitsMode5:CreateFilter(name, db)
	if not db then
		db = {}
		self:tcopy(db, self.filterDefaults)
		table.insert(self.db.profile.filters, db)
	end

	local filter = Filter:new()
	filter.db = db
	filter.db.name = name
	
	table.insert(filters, filter)
	
	filter:AddOptions()
	self:ApplySettings()
end


function HitsMode5:DeleteFilter(name)
	for k, v in ipairs(filters) do
		if v.db.name == name then
			v:destroy()
			wipe(table.remove(filters, k))
		end
	end
	for k, v in ipairs(self.db.profile.filters) do
		if v.name == name then
			table.remove(self.db.profile.filters, k)
		end
	end
	HitsMode5.options.args.filters.args[name] = nil
end



--[[
      SETTINGS APPLICATION -----------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:ReloadSettings()
	for k, v in ipairs(filters) do
		v:destroy()
	end
	filters = {}

	for k, v in ipairs(self.db.profile.filters) do
		self:CreateFilter(v.name, v)
	end

	self:ApplySettings()
end


function HitsMode5:ApplyFilters()
end


function HitsMode5:ApplySettings()
	self:ApplyFilters()
end


--[[
      EVENTS -------------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnSpecialEvent(event, ...)
 if (isEnabled) then
		--
 end
end


function HitsMode5:OnCombatEvent(event, ...)
 if (isEnabled) then
		--
 end
end

